#ifndef _CFG_PARSER_H
#define _CFG_PARSER_H

#define _UHTTPS_MAX_CFG_FILE_LINE_LENGHT 500

//#define _UHTTPS_MAX_PATHNAME_LENGHT FILENAME_MAX
#define _UHTTPS_MAX_PATHNAME_LENGHT 500

struct uhttp_configuration
{
	boolean use_ipv6; // defaults to true
	unsigned short int listening_port; // defaults to 80
	char root_pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // server root directory (defaults to "." - current working directory)
	char log_pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // defaults to "access.log"
	char usersdb_pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // defaults to "uhttps_usersdb.txt"
	unsigned int max_threads; // default to 10
	unsigned int max_processes; // default to 1 = do not use multiprocessing - NOTA: se max_threads>0 viene ignorato
	unsigned int max_connected_clients_count; // RIMUOVERE? -> ricavato dai precedenti
	
	size_t max_cached_file_size; // dimensione massima dei files nella cache (defaults to 1024 = 1kB)
	unsigned int max_cached_file_count; // numero massimo di files nella cache (defaults to 10). Se è "0" la cache viene disabilitata.
	//int max_cached_file_time; // tempo massimo in secondi in cui un file può restare nella cache (viene resettato ogni volta che arriva una nuova richiesta)
	
	/* NO?
	char 401_page_pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // pagina visualizzata in caso di errore 401 (defaults to "401.html")
	char 403_page_pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // pagina visualizzata in caso di errore 403 (defaults to "403.html")
	char 404_page_pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // pagina visualizzata in caso di errore 404 (defaults to "404.html")
	*/
};

/**
  * inizializza a default la struct uhttp_configuration
*/
void uhttps_configuration_init( struct uhttp_configuration* );

/**
  * funzione di debug:
  * stampa su stdout i settaggi attuali
  */
void uhttps_configuration_print( const struct uhttp_configuration* );

/**
  * INPUT: pathname file di configurazione da leggere
  * OUTPUT: modifica la struct uhttp_configuration
 */
void uhttps_configuration_read( struct uhttp_configuration*, const String );


/**
  * INPUT: struct contenente la configurazione corrente
  * OUTPUT: ritorna true se il server è attualmente configurato in modalità multithread
 */
boolean uhttps_is_multithreaded( const struct uhttp_configuration* current_config );
 
/**
  * INPUT: struct contenente la configurazione corrente
  * OUTPUT: ritorna true se il server è attualmente configurato con la file cache attiva
 */
boolean uhttps_file_cache_is_enabled( const struct uhttp_configuration* current_config );


#endif
