
#define _UHTTPS_MAX_PATHNAME_LENGHT 500

struct cached_file
{
	char pathname[ _UHTTPS_MAX_PATHNAME_LENGHT ]; // pathname locale del file
	size_t length;
	void* buffer; // dinamically allocated buffer
	// time_t last_access_time; // ora dell'ultima richiesta del file
	// mime type? -> content-type header
};



/**
  * Inizializza la cache dei file.
  * Precarica i files la cui dimenzione è minore di "current_config->max_cached_file_size".
  */
void uhttps_init_file_cache( struct uhttp_configuration* );

/**
  * Legge un file dalla cache.
  * Se il file è già presente viene ritornato subito.
  * Se il file non è presente viene letto dal disco, e la cache eventualmente aggiornata.
  * Scrive nella struct cached_file "output".
  * Ritorna una delle costanti definite in seguito.
  */
int uhttps_read_cached_file( struct cached_file* output, const char* pathname, const struct uhttp_configuration* current_config );
#define ARG_ERROR -1
#define READ_OK 0
#define FILE_LOCKED 1
#define OPEN_ERROR 2
#define READ_ERROR 3
// TODO? definire enum
