
#ifndef _UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH
	#define _UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH 500
#endif

struct uttps_http_request_parsed {
	// Initial Request Line
		char method[ 10 ];
		char url[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH];
		char http_version[ 5 ];
	
	// Header Lines
		char from[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // usually client email address
		char user_agent[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // e.g. "User-agent: Mozilla/3.0Gold"
		char username[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // decoded from base64
		char password[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // decoded from base64
		char content_type[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // used ONLY when uploading files
		int content_length; // used ONLY when uploading files
	/* ALTERNATIVA:
		campi char* -> puntano direttamente alla request bufferizzata
		il parsing è effettuato con:
			out_parsed_request->from = _search_and_cut(in_request, "From");
			out_parsed_request->... = _search_and_cut(in_request, "...");
	             // MEMO: deve inserire il marcatore di fine stringa dopo ogni header nella request bufferizzata
	*/
	
	void* body;
};

struct uttps_http_response_parsed {
	// Initial Response Line (Status Line)
		char http_version[5];
		int status_code;
		char status_code_description[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // aka reason phrase
	
	// Header Lines
		char location[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH]; // usato solo per status codes 3xx (redirection)
		char server[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH];
		char date[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH];
		char www_authenticate[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH];
		char content_type[_UHTTPS_MAX_HTTP_HEADER_LINE_LENGTH];
		size_t content_length;

	void* body;
	
	// private fields
		boolean _shared_body; // se true indica che il body proviene dalla file cache -> non deve essere disallocato dopo l'invio
		char _server_ip_address[INET6_ADDRSTRLEN]; // indirizzo ip del server (usato da "_handle_http_get" per generare il directory listing)
		size_t _headers_size; // dimensione in bytes degli headers parsati da inviare
};

/**
  * INPUT: arg2: HTTP request bufferizzata
  * OUTPUT: arg1: HTTP request parsata
  * MEMO: "out_parsed_request" deve essere allocato all'esterno!
  * MEMO: lascia vuoti i campi malformed
  */
void uhttps_parse_http_request_headers( struct uttps_http_request_parsed* out_parsed_request, char* in_request );

/**
  * INPUT: arg2: HTTP response parsata
  * OUTPUT: arg1: HTTP response pronta per l'invio, scrive in "in_response->_headers_size"
  */
void uhttps_parse_http_response_headers( char* out_response, struct uttps_http_response_parsed* in_response );
