#ifndef _UHTTPS_H_
#define _UHTTPS_H_
	
	// C stadard library includes
	#include <stdlib.h>
	#include <stdio.h>
	#include <string.h>
	#include <errno.h>
	extern int errno;

	// define string datatype
	typedef char* String;

	// define byte and boolean datatypes (portable)
	#if __USE_ISOC99
		#include <stdbool.h>
		#include <stdint.h>
	#else
		typedef signed char int8_t;
		typedef signed char bool;
		typedef enum {error = -1, false, true} logical;
	#endif
	#if defined(WINDOWS) || defined(WIN32) || defined(_WIN32)
		//typedef BOOLEAN boolean; // already defined?
	#else
		typedef int8_t byte;
		typedef bool boolean;
	#endif
		
	// portable socket type definition
	#if defined(WINDOWS) || defined(WIN32) || defined(_WIN32)
		#include <windows.h>
		#include <winsock2.h>
		#include <ws2tcpip.h>
		#include <process.h>
		typedef SOCKET socket_t;
	#else
		#include <unistd.h>
		#include <sys/socket.h>
		#include <arpa/inet.h>
		#include <netinet/in.h>
		typedef int socket_t;
		#include <pthread.h>
	#endif

	#define _UHTTPS_DEFAULT_CONFIGURATION_PATHNAME "uhttps.cfg"
	#define _UHTTPS_MAX_PATHNAME_LENGHT 500
		
#endif
